function int c4Type(int team, int type)
{
    return c4Types[team][type];
}

function int getC4Type(void)
{
    // no way to case-block this
    if (CheckInventory("EnhancedTimedC4"))
    {
        return 1;
    }
    return 0;
}

function void maxAllAOWAmmo(void)
{
    int ammo; int aMax; int cur; int diff;
    int i;
    
    for (i = 0; i < AOW_AMMOCOUNT; i++)
    {
        ammo = aowAmmoTypes[i];
        aMax  = GetAmmoCapacity(ammo);
        cur  = CheckInventory(ammo);
        diff = aMax - cur;
        
        GiveInventory(ammo, diff);
    }
}

function void doubleAllAOWAmmo(void)
{
    int ammo; int aMax;
    int i;
    
    for (i = 0; i < AOW_AMMOCOUNT; i++)
    {
        ammo = aowAmmoTypes[i];
        aMax  = GetAmmoCapacity(ammo);
        
        SetAmmoCapacity(ammo, aMax * 2);
    }
}

function int giveAOWClassWeapons(int which)
{
    int i; int wep;
    
    if ((which < 0) || (which >= AOW_CLASSCOUNT))
    {
        return 0;
    }
    
    for (i = 0; i < AOW_CWEPCOUNT; i++)
    {
        wep = aowClassWeapons[which][i];
        
        if (StrLen(wep) > 0)
        {
            GiveInventory(wep, 1);
        }
    }
    
    return aowClassNames[which];
}

function void giveAOWSpecialWeapons(void)
{
    int i;

    for (i = 0; i < AOW_ALTWEPCOUNT; i++)
    {
        GiveInventory(aowOtherWeapons[i], 1);
    }
    
    for (i = 0; i < AOW_IWEPCOUNT; i++)
    {
        GiveInventory(aowWeaponItems[i], 30000);
    }
}

function void giveAOWNoSVWeapons(void)
{
    int i;

    for (i = 0; i < AOW_NWEPCOUNT; i++)
    {
        GiveInventory(aowNewWeapons[i], 1);
    }
}

function void giveAOWArmors(void)
{
    int i;
    
    for (i = 0; i < AOW_EARMORCOUNT; i++)
    {
        GiveInventory(aowEArmors[i], 1);
    }
}

function int giveAOWClassArmor(int which)
{
    int i;
    
    if ((which < 0) || (which >= AOW_CARMORCOUNT))
    {
        return 0;
    }
    
    GiveInventory(aowCArmors[which], 1);
    
    return aowCArmors[which];
}

function int toggleAOWClassArmor(int which)
{
    int i;
    
    if ((which < 0) || (which >= AOW_CARMORCOUNT))
    {
        return 0;
    }
    
    if (CheckInventory(aowPArmors[which]))
    {
        TakeInventory(aowPArmors[which], 1);
    }
    else
    {
        GiveInventory(aowCArmors[which], 1);
    }
    
    return aowCArmors[which];
}

function int aowMenuInfo(int which, int arg1, int arg2)
{
    int team, i;
    switch (which)
    {
        case 0:
          return StrParam(s:"Overall \cf", d:arg1 + (arg2<<16), s:"\c- credits");

        case 1:
          if (arg1 == 0) { return "List classes"; }
          return aowClassNames[arg1-1];

        case 2:
          switch (arg1)
          {
            case 0: return "AOW2 + NoSVPure_AOW";
            case 1: return "AOW2";
            case 2: return "NoSVPure_AOW";
          }
          return "wat";

        case 6:
          return aowCArmors[arg1];

        case 7:
          return StrParam(s:"\cf", d:arg1*50, s:"\c- XP");

        case 9:
          if (arg1 == 0) { return "Random"; }
          return CrateEffects[arg1-1];

        case 15:
          if (arg2 < 1) { team = "Your"; }
          else { team = StrParam(s:TeamColorCodes[arg2-1], s:TeamNames[arg2-1]); }
          return StrParam(s:team, s:"\c- ", s:BuildingNames[arg1-1]);

        case 16:
          if (arg1 == 0) { return "No mech"; }
          return aowMechNames[arg1-1];

        case 18:
          if (arg1 == 0) { return "List weapons"; }
          arg1--;
          if (arg1 >= AOW_OWEPCOUNT) { i = aowWeaponItems[arg1 - AOW_OWEPCOUNT]; }
          else { i = aowOtherWeapons[arg1]; }

          return StrParam(d:arg2, s:" of ", s:i);

        case 19:
          if (arg1 >= GetCVar("sv_maxteams")) { return "\cgInvalid team"; }
          if (arg2 == 0) { i = StrParam(n:0); }
          else
          {
              if (!PlayerInGame(arg2-1)) { return "\cgInvalid player"; }
              i = StrParam(n:arg2);
          }

          return StrParam(s:i, s:"\c- to ", s:teamColorCodes[arg1], s:teamNames[arg1]);
    }
    return "";
}
