#include "zcommon.acs"

#library "nosvpure"
#include "commonFuncs.h"

#include "nosvconst.h"
#include "aowConst.h"

#include "nosvfuncs.h"
#include "aowFuncs.h"

#include "aow.h"
#include "nosvtag.h"

#include "nosvmenu.h"
#include "aowMenu.h"

script 729 open
{
    IsServer = 1;

    if (!GetCVar("nosvpure_enabled"))
    {
        ConsoleCommand("set nosvpure_enabled 0");
        ConsoleCommand("archivecvar nosvpure_enabled");
    }

    if (!GetCVar("nosvpure_authnum1"))
    {
        RollAuthNums(0);
    }

    while (1)
    {
        AlertAuth = 0;

        if (GetCVar("nosvpure_rerollauth"))
        {
            RollAuthNums(1);
            AlertAuth = 1;
            ConsoleCommand("unset nosvpure_rerollauth");
        }

        if (GetCVar("nosvpure_printauth"))
        {
            TellAuth();
            ConsoleCommand("unset nosvpure_printauth");
        }

        authNums[0] = GetCVar("nosvpure_authnum1");
        authNums[1] = GetCVar("nosvpure_authnum2");
        authNums[2] = GetCVar("nosvpure_authnum3");
        authNums[3] = GetCVar("nosvpure_authnum4");
        authNums[4] = GetCVar("nosvpure_authnum5");
        authNums[5] = GetCVar("nosvpure_authnum6");
        Delay(1);
    }
}

script 730 (int waitUntilTid, int respawning)
{
    int pln = PlayerNumber();
    int curTID = ActivatorTID();
    int wasAuth, auth;
    
    if (pln == -1) { terminate; }

    if (!respawning)
    {
        ClearNoSVPure();
    }

    while ((curTID == 0) && (waitUntilTid-- > 0))
    {
        Delay(1);
        curTID = ActivatorTID();
    }
    
    playerTIDs[pln] = _defaulttid(-1, 2);

    auth = authenticated[pln];

    while (1)
    {
        playerTIDs[pln] = _defaulttid(-1, 2);

        if (respawning) { Delay(1); continue; }

        wasAuth = auth;
        auth = authenticated[pln];

        if (isDead(0))
        {
            TakeInventory("AllowNoSVPure", 0x7FFFFFFF);
        }

        if (!GetCVar("nosvpure_enabled"))
        {
            ClearNoSVPure();
            TakeInventory("CanIntoNoSVPure", 1);
        }
        else if (!auth && wasAuth)
        {
            DisableNoSVPowers();
            TakeInventory("CanIntoNoSVPure", 1);
        }
        else if (auth)
        {
            GiveInventory("CanIntoNoSVPure", 1);
        }

        if (AlertAuth && auth)
        {
            Print(s:"The auth numbers have changed!\n\npuke -733 ",
                d:authNums[0], s:"    ", d:authNums[1], s:"    ", d:authNums[2], s:"\n\npuke -733 ",
                d:authNums[3], s:"    ", d:authNums[4], s:"    ", d:authNums[5]);
        }

        Delay(1);
    }
}

script 731 ENTER
{
    ACS_ExecuteAlways(730, 0, 70,0,0);
}

script 732 RESPAWN
{
    ACS_ExecuteAlways(730, 0, 70,1,0);
}

script 733 (int n1, int n2, int n3) net
{
    int pln = PlayerNumber();
    int lvl;
    int success;

    if (!GetCVar("nosvpure_enabled"))
    {
        Print(s:"NoSVPure is disabled.");
        terminate;
    }

    if (PlayerNumber() == -1) { terminate; }

    if (authenticated[pln])
    {
        Print(s:"You have already authenticated!");
        terminate;
    }

    lvl = authStage[pln]++ * 3;
    playerAuthNums[pln][lvl]     = n1;
    playerAuthNums[pln][lvl + 1] = n2;
    playerAuthNums[pln][lvl + 2] = n3;

    if (authStage[pln] == AUTHLEVELCOUNT)
    {
        success = CheckAuth(pln);

        if (success == 1)
        {
            authenticated[pln] = 1;
            Print(s:"Successfully authenticated.");
            LocalAmbientSound("misc/p_pkup", 127);
            FadeRange(96, 96, 255, 0.5, 0, 0, 0, 0.0, 0.33333);

            HudMessage(s:"You currently have NoSVPure-AOW loaded.",
                s:"\n\nPuke script -591 for the NoSVPure tools.",
                s:"\nPuke script -592 for the NoSVPure-AOW tools.",
                s:"\n\nPuke script -691 for a NoSVPure menu.",
                s:"\nPuke script -692 for a NoSVPure-AOW menu.",
                s:"\n\n\n\nUse the Tagger weapon to tag people.\nPrimary fire tags, secondary untags everyone.",
                s:"\n\nPuke script -595 to run NoSVPure stuff\non tagged players.",
                s:"\n\nPositive values to script 595 choose NoSVPure options,\nnegative values choose NoSVPure-AOW options.";
                HUDMSG_PLAIN | HUDMSG_LOG, 32019, CR_UNTRANSLATED, 0, 0, 1.0);

            SetHudSize(480, 360, 1);
            HudMessage(s:"See the console for NoSVPure garbage.";
                HUDMSG_FADEOUT, 32019, CR_LIGHTBLUE, 240.0, 260.0, 3.0, 1.0);
            Log(s:"[NoSV] [AUTH] \"", n:0, s:"\c-\" (IDX: ", d:pln, s:") successfully authenticates.");
        }
        else
        {
            Print(s:"Authentication failed.");
            Log(s:"[NoSV] [AUTH] \"", n:0, s:"\c-\" (IDX: ", d:pln, s:") fails to authenticate.");
        }

        authStage[pln] = 0;
        successAuth[pln] = 0;

    }
    else
    {
        Print(s:"Authenticating (", d:authStage[pln], s:" of ", d:AUTHLEVELCOUNT, s:")...\n");
    }
}

script 591 (int which, int a1, int a2) net
{
    int attempts, ahelp, arun, whichname, a1name, a2name;

    if (CanNoSVPure(0))
    {
        ACS_ExecuteWithResult(641, which, a1, a2);
        attempts = "does";
        ahelp = "checks";
        arun = "runs";
    }
    else
    {
        attempts = "tries to do";
        ahelp = "tries to check";
        arun = "tries to run";
    }

    if (which == 0)
    {
        Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:ahelp, s:" help.");
    }
    else if (which > 0 && which <= CHOICECOUNT)
    {
        which--;

        whichname = ChoiceNames[which][0];

        if (StrLen(ChoiceNames[which][1]) != 0)
        {
            a1name = StrParam(s:" (\"", s:ChoiceNames[which][1], s:"\" is ", d:a1, s:")");
        }
        else
        {
            a1name = "";
        }

        if (StrLen(ChoiceNames[which][2]) != 0)
        {
            a2name = StrParam(s:" (\"", s:ChoiceNames[which][2], s:"\" is ", d:a2, s:")");
        }
        else
        {
            a2name = "";
        }

        Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:attempts, s:" \"", s:whichname, s:"\"", s:a1name, s:a2name, s:".");
    }
    else
    {
        Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:arun, s:" script 591 (", d:which, s:", ", d:a1, s:", ", d:a2, s:").");
    }
}

script 641 (int which, int a1, int a2)
{
    int pln = PlayerNumber(), myTID = ActivatorTID(), myTeam = GetPlayerInfo(pln, PLAYERINFO_TEAM);
    // We can safely assume our player has a TID; either we or some other mod set it
    
    int x, y, z, i, j, k;
    int curTID, hisTID, hisName;
    int hpSec, hpCount, hpOver, hpOverI;
    int targetTID, targetName, targetHealth, targetMax, targetTeam, targetAlliance;
    int hpColor, nameColor, statStr;
    int isMonster, isFriendly, isEnemy, hasTeam, sameTeam, freeForAll;
    int summonMon, printStr;

    int authed = authenticated[pln];

    switch (which)
    {
      case 1:
        if (a1 < 1 || a1 > WEPCOUNT)
        {
            if (authed)
            {
                if (a1 != 0) { Print(s:"Invalid weapon index ", d:a1); break; }


                printStr = "";
                SetHudSize(640, 480, 1);
                HudMessage(s:"Weapons:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 500.0, 34.0, 4.0, 1.0);

                for (i = 0; i < WEPCOUNT; i++)
                {
                    j = cond(i%2, CR_LIGHTBLUE, CR_WHITE);
                    k = 50.0 + (i * 11.0);

                    printStr = StrParam(s:printStr, s:padStringR(StrParam(d:i+1), " ", 2), s:" - ", s:weapons[i], s:"\n");

                    HudMessage(d:i+1;  HUDMSG_FADEOUT, 49235+(i*3), CR_GOLD,  450.4, k, 4.0, 1.0);
                    HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(i*3), CR_GREEN, 463.4, k, 4.0, 1.0);
                    HudMessage(s:weapons[i]; HUDMSG_FADEOUT, 49237+(i*3), j, 470.1, k, 4.0, 1.0);
                }

                HudMessage(s:printStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
                HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);
            }
            break;
        }

        a1--;

        if ((a2 == 1) || (a2 == 2))
        {
            Spawn(weapons[a1], GetActorX(0), GetActorY(0), GetActorZ(0));
        }
        
        if ((a2 == 0) || (a2 == 2))
        {
            Giveinventory(weapons[a1], 1);
        }
        
        GiveInventory("AmmoSatchel", 1);   // YES AMMO SATCHEL.
        GiveInventory(wepAmmo[a1], GetAmmoCapacity(wepAmmo[a1]));

        if (authed)
        {
            if (a2 == 0) { Print(s:"Gave the ", s:weapons[a1]); }
            if (a2 == 1) { Print(s:"Spawned the ", s:weapons[a1], s:" at your feet"); }
            if (a2 == 2) { Print(s:"Gave the ", s:weapons[a1], s:" and spawned it at your feet"); }
        }
        break;
        
      case 2:
        if (a1 != 3)
        {
            for (i = 0; i < WEPCOUNT; i++)
            {
                if (a1 == 1 || a1 == 2 || a1 == 5)
                {
                    Spawn(weapons[i], GetActorX(0), GetActorY(0), GetActorZ(0));
                    Spawn("AmmoSatchel", GetActorX(0), GetActorY(0), GetActorZ(0));
                }
                
                if (a1 == 0 || a1 == 2 || a1 == 4)
                {
                    GiveInventory(weapons[i], 1);
                    GiveInventory("AmmoSatchel", 1);
                }
            }

            for (i = 0; i < AMMOCOUNT; i++)
            {
                GiveInventory(nosvAmmo[i], GetAmmoCapacity(nosvAmmo[i]));
            }
        }
        
        if (a1 != 4 && a1 != 5)
        {
            for (i = 0; i < CWEPCOUNT; i++)
            {
                GiveInventory(cWeps[i], 1);
            }
        }

        if (authed)
        {
            switch (a1)
            {
                case 0: Print(s:"All weapons given, Doom wepon given and spawned"); break;
                case 1: Print(s:"All weapons given, Doom wepon given directly"); break;
                case 2: Print(s:"All weapons given, Doom wepon spawned at feet"); break;
                case 3: Print(s:"NoSVPure weapons given"); break;
                case 4: Print(s:"Doom weapons given directly"); break;
                case 5: Print(s:"Doom weapons spawned at feet"); break;
            }
        }

        break;
        
      case 3:
        SetActorProperty(0, APROP_SpawnHealth, (a2 << 16) + a1);
        
      case 4:
        SetActorProperty(0, APROP_Health, (a2 << 16) + a1);
        break;
        
      case 5:
        SetActorProperty(0, APROP_Speed, percFloat(a1, a2));
        break;
        
      case 6:
        SetActorProperty(0, APROP_JumpZ, percFloat(a1, a2));
        break;
        
      case 7:
        loopInvuln[pln] = !loopInvuln[pln];
        i = 0;
        
        while (loopInvuln[pln])
        {
            if (i++ % (55*35) == 0) { GiveInventory("PowerInvulnGold60", 1); }
            Delay(1);
        }

        TakeInventory("PowerInvulnGold60", 1);
        break;
        
      case 8:
        loopInvis[pln] = !loopInvis[pln];
        i = 0;

        while (loopInvis[pln])
        {
            if (i++ % 18 == 0)
            {
                SetActorProperty(0, APROP_RenderStyle, STYLE_None);
                SetPlayerProperty(0, 1, 1);
                GiveInventory("InvisOn", 1); 
            }
            Delay(1);
        }

        SetActorProperty(0, APROP_RenderStyle, STYLE_Normal);
        SetPlayerProperty(0, 0, 1);
        GiveInventory("InvisOff", 1); 
        break;
        
      case 9:
        loopInstagib[pln] = !loopInstagib[pln];
        i = 0;
        
        while (loopInstagib[pln])
        {
            if (i++ % (55*35) == 0) { GiveInventory("PowerInstagib", 1); }
            Delay(1);
        }

        TakeInventory("PowerInstagib", 1);
        break;
        
      case 10:
        loopNoclip[pln] = !loopNoclip[pln];
        
        while (loopNoclip[pln])
        {
            GiveInventory("NoclipOn", 1);
            i = GetActorVelX(0);
            j = GetActorVelY(0);
            k = GetActorVelZ(0);

            SetActorVelocity(0, FixedMul(i, 0.9), FixedMul(j, 0.9), FixedMul(k, 0.9), 0,0);
            Delay(1);
        }

        GiveInventory("NoclipOff", 1);
        break;
        
      case 11:
        loopHeal[pln] = !loopHeal[pln];

        if (a1 < 0)
        {
            a1 = -a1;
            k = 1;  // Damage
        }
        
        hpSec = a1 << 16;

        // arg2 is a bitfield
        //  1: silent
        //  2: persistent
        //  4: do ammo
        
        while (loopHeal[pln])
        {
            if (isDead(0))
            {
                if (k && (~a2 & 2)) { break; }
                Delay(1);
                continue;
            }

            hpCount += (hpSec / 35);
            hpOver = hpCount - ((hpCount << 16) >> 16); // remove fractional part 
            
            if (hpOver >= 1.0)
            {
                hpOverI = hpOver >> 16;

                if (k)
                {
                    if ((a2 & 1) && hpOverI < GetActorProperty(0, APROP_Health))
                    {
                        AddActorProperty(0, APROP_Health, -hpOverI);
                    }
                    else
                    {
                        Thing_Damage2(0, hpOverI, "Massacre");
                    }
                }
                else
                {
                    giveHealth(hpOverI);

                    if (a2 & 4)
                    {
                        GiveInventory("Clip", hpOverI);
                        GiveInventory("Shell", hpOverI);
                        GiveInventory("RocketAmmo", hpOverI);
                        GiveInventory("Cell", hpOverI);
                    }
                }
            }
            
            hpCount -= hpOver;
            
            Delay(1);
        }

        loopHeal[pln] = 0;
        break;
        
      case 12:
        if (a2) { loopSpy[pln] = !!a1; }
        else { loopSpy[pln] = !loopSpy[pln]; }
        
        while (loopSpy[pln])
        {
            
            for (i = 0; i < PLAYERMAX; i++)
            {
                curTID = playerTIDs[i];
                if ((i == pln) || (curTID == 0))
                {
                    continue;
                }
                
                hudMessageOnActor(curTID, -1, "BIGFONT", "X");
            }
            Delay(35);
        }
        break;
        
      case 13:
        targetHealth = ACS_ExecuteWithResult(TARGET_CHECK, CHECK_HP,0,0);
        targetTID    = ACS_ExecuteWithResult(TARGET_CHECK, CHECK_TID,0,0);
        targetName   = ACS_ExecuteWithResult(TARGET_CHECK, CHECK_NAME,0,0);
        targetTeam   = ACS_ExecuteWithResult(TARGET_CHECK, CHECK_TEAM,0,0);
        targetMax    = ACS_ExecuteWithResult(TARGET_CHECK, CHECK_MAXHP,0,0);
        
        if (targetHealth > targetMax) { hpColor = "\cn"; }
        else { hpColor = "\ca"; }
        
        isMonster  = (targetTeam == -1);
        isFriendly = ACS_ExecuteWithResult(TARGET_CHECK, CHECK_FRIEND,0,0);
        sameTeam   = (myTeam == targetTeam);
        hasTeam    = !((targetTeam == 255) | (targetTeam == -1));
        freeForAll = isFreeForAll();
        
        if (isMonster)
        {
            if (hasTeam) { isEnemy = !sameTeam; }
            else { isEnemy = !isFriendly; }
        }
        else { isEnemy = freeForAll || !sameTeam; }
        
        if (myTID == targetTID) { isEnemy = -1; }
        
        if (isEnemy == -1) { targetAlliance = "\cfYOU\c-"; }
        else if (isEnemy) { targetAlliance = "\cgENEMY"; }
        else { targetAlliance = "\cdALLY"; }
        
        if ((targetTeam == 255) || (targetTeam == -1) || !isTeamGame())
        {
            nameColor = "\ck";
        }
        else
        {
            nameColor = teamColorCodes[targetTeam];
        }
        
        if (targetMax > 0)
        {
            statStr = StrParam(s:nameColor, s:"\"", s:targetName, s:nameColor,
            s:"\"\c-: (", s:targetAlliance, s:"\c-) ", s:hpColor, d:max(targetHealth, 0),
            s:"\cd/\cb", d:targetMax, s:"\c- (tid: ", d:targetTID, s:")");
        }
        else if (targetMax < 0)
        {
            statStr = StrParam(s:nameColor, s:"\"", s:targetName, s:nameColor,
            s:"\"\c-: (", s:targetAlliance, s:"\c-) \cgUNDEAD\c- (tid: ",
            d:targetTID, s:")");
        }
        else
        {
            statStr = StrParam(s:nameColor, s:"\"", s:targetName, s:nameColor,
            s:"\"\c-: (", s:targetAlliance, s:"\c (tid: ", d:targetTID, s:")");
        }
        
        HudMessage(s:statStr; HUDMSG_FADEOUT, 10595, CR_WHITE, 1.5, 0.2, 2.0, 0.5);
        break;
        
      case 14:
        SetActivatorToTarget(0);
        if (ActivatorTID() == myTID) // oh shit, don't do anything stupid
        {
            break;
        }
        
        targetHealth = GetActorProperty(0, APROP_Health);
        SetActorProperty(0, APROP_Health, a1);
        
        if (a1 < -(getMaxHealth() || 100))
        {
            SetActorState(0, "XDeath");
        }
        else if (a1 <= 0)
        {
            SetActorState(0, "Death");
        }
        else if ((a1 < targetHealth) && (a2 == 0))
        {
            SetActorState(0, "Pain");
        }
        else if ((a1 > getMaxHealth()) && (a2 == 0))
        {
            SetActorProperty(0, APROP_Friendly, 1);
        }
        
        SetActivator(myTID);
        break;
        
      case 15:
        for (i = 0; i < KEYCOUNT; i++)
        {
            GiveInventory(keys[i], 1);
        }
        break;
        
      case 16:
        loopFreeze[pln] = !loopFreeze[pln];
        
        if (loopFreeze[pln] == 0)
        {
            TakeInventory("PowerTimeFreeze60", 1);
        }
        else
        {
            while (loopFreeze[pln])
            {
                GiveInventory("PowerTimeFreeze60", 1);
                Delay(55*35);   // allow for 5 seconds of lag
            }
        }
        break;
        
      case 17:
        SetActivatorToTarget(0);
        
        if (ActivatorTID() == myTID) { break; } // NO HEEL SELF
        
        giveHealthFactor(a1, itof(a2)/100);
        targetHealth = GetActorProperty(0, APROP_Health);
        
        if (targetHealth > getMaxHealth())
        {
            SetActorProperty(0, APROP_Friendly, 1);
        }
        break;
        
      case 18:
        giveHealthFactor(a1, itof(a2)/100);
        break;

      case 19:
        if (a1 == 0)
        {
            SetHudSize(640, 480, 1);
            HudMessage(s:"Monsters:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 500.0, 84.0, 4.0, 1.0);

            for (i = 0; i < MONCOUNT; i++)
            {
                if (i%2) { j = CR_LIGHTBLUE; }
                else { j = CR_WHITE; }
                
                k = 100.0 + (i * 11.0);

                HudMessage(d:i+1;  HUDMSG_FADEOUT, 59235+(i*3), CR_GOLD,  457.2, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 59236+(i*3), CR_GREEN, 463.4, k, 4.0, 1.0);
                HudMessage(s:monsters[i]; HUDMSG_FADEOUT, 59237+(i*3), j, 470.1, k, 4.0, 1.0);
            }

            break;
        }
        else if (a1 < 1 || (a1 > MONCOUNT))
        {
            if (authed) { Print(s:"Invalid monster index ", d:a1); }
            break;
        }
        

        summonMon = monsters[--a1];
        hisTID = unusedTID(80000, 90000);
        j = spawnDistance(summonMon, 128, hisTID);

        if (!a2)
        {
            SetActorProperty(hisTID, APROP_Friendly, 1);
        }
        break;

      case 20:
        if (a1 == 0)
        {
            if (!authed) { break; }
            printStr = "";
            SetHudSize(640, 480, 1);
            HudMessage(s:"Weapons:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 540.0, 34.0, 4.0, 1.0);

            for (i = 0; i < LWEPCOUNT; i++)
            {
                j = cond(i%2, CR_LIGHTBLUE, CR_WHITE);
                k = 50.0 + (i * 11.0);

                printStr = StrParam(s:printStr, s:padStringR(StrParam(d:i+1), " ", 2), s:" - ", s:lelweps[i][0], s:"\n");

                HudMessage(d:i+1;  HUDMSG_FADEOUT, 49235+(i*3), CR_GOLD,  450.4, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(i*3), CR_GREEN, 463.4, k, 4.0, 1.0);
                HudMessage(s:lelweps[i][0]; HUDMSG_FADEOUT, 49237+(i*3), j, 470.1, k, 4.0, 1.0);
            }

            HudMessage(s:printStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
            HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);
            break;
        }
        else if ((a1 <= 0) || (a1 > LWEPCOUNT))
        {
            if (authed) { Print(s:"Invalid weapon index: \cd", d:a1); }
            break;
        }

        i = a1-1;

        if (a2 == 0 || a2 == 2)
        {
            GiveInventory(lelweps[i][0], 1);
            if (StrLen(lelweps[i][1])) { GiveInventory(lelweps[i][1], GetAmmoCapacity(lelweps[i][1])); }
            if (StrLen(lelweps[i][2])) { GiveInventory(lelweps[i][2], GetAmmoCapacity(lelweps[i][2])); }
            SetWeapon(lelweps[i][0]);
        }
        if (a2 == 1 || a2 == 2)
        {
            Spawn(lelweps[i][0], GetActorX(0), GetActorY(0), GetActorZ(0));
        }

        if (authed)
        {
            Print(s:"Gave the ", s:lelweps[i][0]);
        }
        break;

      case 21:
        loopTele[pln] = !loopTele[pln];

        if (!loopTele[pln]) { break; }

        if (a1 < 0 || a1 >= PLAYERMAX)
        {
            if (authed) { Print(s:"Invalid player number ", d:a1); }
            break;
        }

        if (a1 == pln)
        {
            if (authed) { Print(s:"shitting under yourself\n(that's your player number)"); }
            break;
        }

        if (!PlayerInGame(a1))
        {
            if (authed) { Print(s:"That player is not in the game."); }
            break;
        }
            

        for (i = 0; i < max(1, a2); i++)
        {
            if (!loopTele[pln]) { break; }

            hisTID = playerTIDs[a1];

            x = GetActorX(hisTID);
            y = GetActorY(hisTID);
            z = GetActorZ(hisTID);

            x -= 64 * cos(GetActorAngle(hisTID));
            y -= 64 * sin(GetActorAngle(hisTID));

            if (HasRoom("PlayerRoomCheck", x, y, z) || a2)
            {
                SetActorPosition(0, x, y, z, 0);
                x = GetActorVelX(hisTID);
                y = GetActorVelY(hisTID);
                z = GetActorVelZ(hisTID);

                SetActorAngle(0, GetActorAngle(hisTID));
                SetActorVelocity(0, x, y, z, 0,0);
            }
            else
            {
                if (authed) { Print(s:"Cannot teleport; space is blocked."); }
            }

            Delay(1);
        }

        loopTele[pln] = 0;
        break;

      case 22:
        if (a1 == 0)
        {
            PrintPoints();
            break;
        }

        k = (a1 < 0);  // delete?
        a1 = abs(a1) - 1;

        if (a1 >= POINTCOUNT)
        {
            Print(s:"Point index ", d:a1+1, s:"is too high; the range is [1, ", d:POINTCOUNT, s:"].");
            break;
        }

        for (i = 0; i < POINTCOUNT; i++)
        {
            if (i == a1)
            {
                if (k)
                {
                    TeleportPoints[i][0] = 0;
                    TeleportPoints[i][1] = 0;
                    TeleportPoints[i][2] = 0;
                    TeleportPoints[i][3] = 0;
                    Print(s:"Deleted teleport point ", d:a1+1, s:".");
                    break;
                }
                else if (TeleportPoints[i][0])
                {
                    Print(s:"Teleport point ", d:a1+1, s:" is already taken!");
                    break;
                }
                else
                {
                    TeleportPoints[i][0] = 1;
                    TeleportPoints[i][1] = GetActorX(0);
                    TeleportPoints[i][2] = GetActorY(0);
                    TeleportPoints[i][3] = GetActorZ(0);
                    Print(s:"Set teleport point ", d:a1+1, s:" successfully.");
                    break;
                }
            }
        }
        break;

      case 23:
        if (a1 == 0)
        {
            PrintPoints();
            break;
        }

        a1 = abs(a1) - 1;

        if (a1 >= POINTCOUNT)
        {
            Print(s:"Point index ", d:a1+1, s:"is too high; the range is [1, ", d:POINTCOUNT, s:"].");
            break;
        }

        if (TeleportPoints[a1][0])
        {
            SetActorVelocity(0, 0,0,0, 0,0);
            SetActorPosition(0, TeleportPoints[a1][1], TeleportPoints[a1][2], TeleportPoints[a1][3], !a2);
        }
        else
        {
            Print(s:"Teleport point ", d:a1+1, s:" isn't used.");
        }
        break;

      case 24:
        if (a1 == 1) { SetPlayerProperty(0, 1, PROP_TOTALLYFROZEN); }
        else { SetPlayerProperty(0, 0, PROP_TOTALLYFROZEN); }
        break;

      case 25:
        SetActorProperty(0, APROP_Gravity, percFloat(a1, a2));

        if (authed) { Print(s:"Set gravity to ", d:(a1*100) + a2, s:"%"); }
        break;

      case 26:
        if (a1 < 1 || a1 > RUNECOUNT)
        {
            printStr = "";
            SetHudSize(640, 480, 1);
            HudMessage(s:"Runes:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 540.0, 34.0, 4.0, 1.0);

            for (i = 0; i < RUNECOUNT; i++)
            {
                j = cond(i%2, CR_LIGHTBLUE, CR_WHITE);
                k = 50.0 + (i * 11.0);

                printStr = StrParam(s:printStr, s:padStringR(StrParam(d:i+1), " ", 2), s:" - ", s:runes[i], s:"\n");

                HudMessage(d:i+1;  HUDMSG_FADEOUT, 49235+(i*3), CR_GOLD,  450.4, k, 4.0, 1.0);
                HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(i*3), CR_GREEN, 463.4, k, 4.0, 1.0);
                HudMessage(s:runes[i]; HUDMSG_FADEOUT, 49237+(i*3), j, 470.1, k, 4.0, 1.0);
            }

            HudMessage(s:printStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
            HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);
            break;
        }

        i = runes[--a1];

        if (CheckInventory(i))
        {
            TakeInventory(i, 1);
            if (authed) { Print(s:"Took rune ", s:i); }
        }
        else
        {
            GiveInventory(i, 1);
            if (authed) { Print(s:"Gave rune ", s:i); }
        }
        break;

      case 27:
        loopFly[pln] = !loopFly[pln];
        if (authed) { Print(s:"Flying is ", s:cond(loopFly[pln], "\cdON", "\cgOFF"), s:"\c-."); }

        while (loopFly[pln])
        {
            if (isDead(0)) { Delay(1); continue; }

            SetPlayerProperty(0, 0, PROP_FLIGHT);
            SetPlayerProperty(0, 1, PROP_FLIGHT);
            Delay(1);
        }

        SetPlayerProperty(0, 0, PROP_FLIGHT);
        loopFly[pln] = 0;
        break;

      case 28:
        Team_GivePoints(myTeam, a1, 0);
        break;

      case 29:
        if (a1 < 1 || a1 > SPHERECOUNT)
        {
            if (authed)
            {
                if (a1 != 0) { Print(s:"Invalid sphere index ", d:a1); break; }
                printStr = "";
                SetHudSize(640, 480, 1);
                HudMessage(s:"Spheres:"; HUDMSG_FADEOUT, 59234, CR_GOLD, 500.0, 34.0, 4.0, 1.0);

                for (i = 0; i < SPHERECOUNT; i++)
                {
                    j = cond(i%2, CR_LIGHTBLUE, CR_WHITE);
                    k = 50.0 + (i * 11.0);

                    printStr = StrParam(s:printStr, s:padStringR(StrParam(d:i+1), " ", 2), s:" - ", s:spheres[i], s:"\n");

                    HudMessage(d:i+1;  HUDMSG_FADEOUT, 49235+(i*3), CR_GOLD,  450.4, k, 4.0, 1.0);
                    HudMessage(s:"-";  HUDMSG_FADEOUT, 49236+(i*3), CR_GREEN, 463.4, k, 4.0, 1.0);
                    HudMessage(s:spheres[i]; HUDMSG_FADEOUT, 49237+(i*3), j, 470.1, k, 4.0, 1.0);
                }

                HudMessage(s:printStr; HUDMSG_PLAIN|HUDMSG_LOG, 1, CR_WHITE, 0,0,0);
                HudMessage(s:""; HUDMSG_PLAIN, 1, CR_WHITE, 0,0,1);
            }

            break;
        }

        GiveInventory(spheres[--a1], 1);

        if (authed) { Print(s:"Gave ", s:spheres[a1]); }
        break;

      case 30:
        if (!authed) { break; }

        // Don't do accidental kicks/bans
        if (a1 == 0) { break; }

        a1--;

        if (!(PlayerInGame(a1) || PlayerIsSpectator(a1)))
        {
            Print(s:"There is no player ", d:a1, s:".");
            break;
        }

        j = " \"YOU GOT DARWIN'D\"";
        if (a1 == pln)
        {
            j = " \"darwinism in action\"";
            Print(s:"You're a smart one, aren't you.");
        }

        
        if (a2 < 0)
        {
            i = StrParam(s:"ban_idx ", d:a1, s:" perm", s:j);
        }
        
        if (a2 == 0)
        {
            i = StrParam(s:"kick_idx ", d:a1, s:j);
        }

        if (a2 > 0)
        {
            i = StrParam(s:"ban_idx ", d:a1, s:" ", d:a2, s:"min", s:j);
        }

        if (ConsolePlayerNumber() != -1)
        {
            Print(s:"Would run commmand:\n", s:i);
        }
        else
        {
            ConsoleCommand(i);
            Print(s:"Ran commmand:\n", s:i);
        }
        break;
        
      default:
        if (authed)
        {
            HudMessage(s:NOSVPURE_HELP; HUDMSG_PLAIN | HUDMSG_LOG, 27100, CR_GOLD, 0.0, 0.0, 0.0);
            HudMessage(s:NOSVPURE_HELP2; HUDMSG_PLAIN | HUDMSG_LOG, 27100, CR_GOLD, 0.0, 0.0, 0.0);
            HudMessage(s:"See the console for help."; HUDMSG_PLAIN, 27100, CR_GOLD, 1.5, 0.47, 5.0);
        }
        break;
    }

    TakeInventory("AllowNoSVPure", 0x7FFFFFFF);
}

script TARGET_CHECK (int which)
{
    int ret = 0;
    SetActivatorToTarget(0);
    int hisPln = PlayerNumber();
    
    switch (which)
    {
      case CHECK_TID:
        ret = ActivatorTID();
        break;
        
      case CHECK_NAME:
        ret = StrParam(n:0);
        break;
        
      case CHECK_TEAM:
        ret = GetPlayerInfo(hisPln, PLAYERINFO_TEAM);
        break;
        
      case CHECK_HP:
        ret = GetActorProperty(0, APROP_Health);
        break;
        
      case CHECK_MAXHP:
        ret = getMaxHealth();
        
        if ((hisPln != -1) && (ret == 0))
        {
            ret = 100;
        }
        break;
        
      case CHECK_FRIEND:
        ret = GetActorProperty(0, APROP_Friendly);
        break;
    }
    
    SetResultValue(ret);
}

script 734 (int pln) disconnect
{
    authenticated[pln] = 0;
}

