script 594 (int pln) net
{
    pln--;
    int verbose, lastTime;

    if (!CanNoSVPure(0))
    {
        if (pln == -1)
        {
            if (TagNag[PlayerNumber()] + 8 < Timer())
            {
                Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") tried to tag a target.");
            }
            TagNag[PlayerNumber()] = Timer();
        }
        else
        {
            Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") tried to tag \"", n:pln+1, s:"\c-\" (IDX ", d:pln, s:").");
        }

        SetResultValue(0);
        terminate;
    }

    int oldTID = ActivatorTID();
    int myTID = _defaulttid(-1, 2);
    int myPln = PlayerNumber();

    if (myPln == -1) { SetResultValue(0); terminate; }
    TagScripts[myPln][0] = 0;

    if (pln > -1 && pln < PLAYERMAX)
    {
        if (!PlayerInGame(pln))
        {
            Print(s:"That player isn't in the game.");
            SetResultValue(0);
            terminate;
        }

        verbose = 1;
        SetActivator(playerTIDs[pln]);
    }
    else
    {
        SetActivatorToTarget(0);
    }

    if (PlayerNumber() == myPln)
    {
        if (verbose) { Print(s:"You can't tag yourself."); }

        Thing_ChangeTID(myTID, oldTID);
        SetResultValue(0);
        terminate;
    }

    if (ClassifyActor(0) & ACTOR_WORLD)
    {
        if (verbose) { Print(s:"No actor with TID ", d:ActivatorTID(), s:" exists."); }

        SetResultValue(0);
        terminate;
    }

    int yourPln = PlayerNumber();

    if (yourPln == -1)
    {
        SetActivator(myTID);
        Thing_ChangeTID(myTID, oldTID);

        Print(s:"Can't tag non-players!");
        SetResultValue(0);
        terminate;
    }

    int oldTID2 = ActivatorTID();
    int yourTID = _defaulttid(-1, 2);
    int yourName = StrParam(n:0);

    SetActivator(myTID);
    Thing_ChangeTID(myTID, oldTID);

    Print(s:"Tagged ", s:yourName, s:"\c- (", d:yourTID, s:") successfully.");
    Log(s:"[NoSV] \"", n:0, s:"\c-\" tagged \"", s:yourName, s:"\c-\".");
    SetResultValue(1);

    SetActivator(yourTID);
    Thing_ChangeTID(yourTID, oldTID2);

    lastTime = condFalse(TagScripts[myPln][4] == 0, -1);

    while (1)
    {
        while (!TagScripts[myPln][0] || TagScripts[myPln][4] == lastTime)
        {
            Delay(1);
        }

        int snum = TagScripts[myPln][0];
        int arg1 = TagScripts[myPln][1];
        int arg2 = TagScripts[myPln][2];
        int arg3 = TagScripts[myPln][3];

        if (snum != -1)
        {
            ACS_ExecuteWithResult(abs(snum), arg1, arg2, arg3);
            lastTime = Timer();

            if (snum > 0) { break; }
        }
    }
}

// NoSVPure

script 595 (int which, int a1, int a2) net
{
    int attempts, ahelp, arun, whichname, a1name, a2name;
    int pln = PlayerNumber();
    int snum;

    if (CanNoSVPure(0))
    {
        attempts = "does";
        ahelp = "aborts";
        arun = "runs";

        if (pln == -1) { terminate; }

        snum = cond(which < 0, -641, 641);
        which = abs(which);

        if (which != 0)
        {
            Print(s:"Running script ", d:snum, s:"(", d:which, s:", ", d:a1, s:", ", d:a2, s:") on all tagged players");
            SetTag(pln, snum, abs(which), a1, a2);
        }
        else
        {
            Print(s:"Script tagging aborted.");
            SetTag(pln, -1, 0, 0, 0);
        }

        Delay(1);

        SetTag(pln, 0,0,0,0);
    }
    else
    {
        attempts = "tries to do";
        ahelp = "tries to abort";
        arun = "tries to run";
    }

    if (which == 0)
    {
        Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:ahelp, s:" tagging.");
    }
    else if (which > 0 && which <= CHOICECOUNT)
    {
        which--;

        whichname = ChoiceNames[which][0];

        if (StrLen(ChoiceNames[which][1]) != 0)
        {
            a1name = StrParam(s:" (\"", s:ChoiceNames[which][1], s:"\" is ", d:a1, s:")");
        }
        else
        {
            a1name = "";
        }

        if (StrLen(ChoiceNames[which][2]) != 0)
        {
            a2name = StrParam(s:" (\"", s:ChoiceNames[which][2], s:"\" is ", d:a2, s:")");
        }
        else
        {
            a2name = "";
        }

        Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:attempts, s:" \"", s:whichname, s:"\"", s:a1name, s:a2name, s:" on all tagged players.");
    }
    else
    {
        Log(s:"[NoSV] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:arun, s:" script 641 (", d:which, s:", ", d:a1, s:", ", d:a2, s:") on all tagged players.");
    }
}

// NoSVPure-AOW

script 596 (int which, int a1, int a2) net
{
    int attempts, ahelp, arun, whichname, a1name, a2name;
    int pln = PlayerNumber();
    int snum;

    if (CanNoSVPure(0))
    {
        attempts = "does";
        ahelp = "aborts";
        arun = "runs";

        if (pln == -1) { terminate; }

        snum = cond(which < 0, -642, 642);  // Literally the only line different here
        which = abs(which);

        if (which != 0)
        {
            Print(s:"Running script ", d:snum, s:"(", d:which, s:", ", d:a1, s:", ", d:a2, s:") on all tagged players");
            SetTag(pln, snum, abs(which), a1, a2);
        }
        else
        {
            Print(s:"Script tagging aborted.");
            SetTag(pln, -1, 0, 0, 0);
        }

        Delay(1);

        SetTag(pln, 0,0,0,0);
    }
    else
    {
        attempts = "tries to do";
        ahelp = "tries to abort";
        arun = "tries to run";
    }

    if (which == 0)
    {
        Log(s:"[NoSV] [AOW] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:ahelp, s:" tagging.");
    }
    else if (which > 0 && which <= CHOICECOUNT_AOW)
    {
        which--;

        whichname = AOWChoiceNames[which][0];

        if (StrLen(AOWChoiceNames[which][1]) != 0)
        {
            a1name = StrParam(s:" (\"", s:AOWChoiceNames[which][1], s:"\" is ", d:a1, s:")");
        }
        else
        {
            a1name = "";
        }

        if (StrLen(AOWChoiceNames[which][2]) != 0)
        {
            a2name = StrParam(s:" (\"", s:AOWChoiceNames[which][2], s:"\" is ", d:a2, s:")");
        }
        else
        {
            a2name = "";
        }

        Log(s:"[NoSV] [AOW] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:attempts, s:" \"", s:whichname, s:"\"", s:a1name, s:a2name, s:" on all tagged players.");
    }
    else
    {
        Log(s:"[NoSV] [AOW] \"", n:0, s:"\c-\" (IDX: ", d:PlayerNumber(), s:") ", s:arun, s:" script 642 (", d:which, s:", ", d:a1, s:", ", d:a2, s:") on all tagged players.");
    }
}
